%define build_mit_on_cmdline %{?build_mit:1}%{!?build_mit:0}


%define build_with_mit 1
%if %{build_mit_on_cmdline}
%if %{build_mit}
%define build_with_mit 1
%else
%define build_with_mit 0
%endif
%endif


# Make sure RPM doesn't complain about installed but non-packaged files.
%define __check_files  %{nil}

# Don't strip files - rpm magic ?!?!?
%define debug_package %{nil}
%define __spec_install_post %{nil}

Summary: arc - authenticated remote command
Name: arc
Version: 44
Release: 20.cern
Epoch: 0
License: GPL
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Packager: Rainer Toebbicke <Rainer.Toebbicke@cern.ch>
Vendor: Scientific Linux
Group: Networking/misc
%if %{build_with_mit}
BuildRequires: krb5-devel krb5-libs openafs-devel openafs-compat openssl-devel
Requires: openssl krb5-libs
%else
BuildRequires: heimdal-lib heimdal-devel krb4-devel krb4-libs openafs-devel openafs-compat
%endif
ExclusiveArch: %{ix86} x86_64 ia64
Provides: cern-config-keytab

Source0: http://afs/cern.ch/project/afs/dev/arc/arc-src.tar.bz2

%description
The arc service starts designated procedures on a remote host under the 'root'
userid, without any need for a full login to the system but rather providing
certified information about the caller's identify to the procedure.

In this release, the arc service provides a Kerberos-authenticated channel
(eventually authentication using grid certificates will be supported) into a
perl program on the server side. It is up to the perl program to act according
to the certified identity of the caller.

%package client
#Requires: heimdal-lib
Summary: arc client side including some arc-based utilities
Group: Networking/misc

%description client
The arc service starts designated procedures on a remote host under the 'root'
userid, without any need for a full login to the system but rather providing
certified information about the caller's identify to the procedure.

In this release, the arc service provides a Kerberos-authenticated channel
(eventually authentication using grid certificates will be supported) into a
perl program on the server side. It is up to the perl program to act according
to the certified identity of the caller.

%package server
Requires: cern-config-keytab xinetd
Summary: arc - server side
Group: Networking/misc

%description server
The arc service starts designated procedures on a remote host under the 'root'
userid, without any need for a full login to the system but rather providing
certified information about the caller's identify to the procedure.

In this release, the arc service provides a Kerberos-authenticated channel
(eventually authentication using grid certificates will be supported) into
a perl program on the server side. It is up to the perl program to 
act according to the certified identity of the caller.

###############################################################################
#
# preparation
#
###############################################################################

%prep

%setup -q -c -n %{name}-%{version}

###############################################################################
#
# building
#
###############################################################################

%build

cd src
%if %{build_with_mit}
make -f makefile.mit arc arcd
%else
make -f makefile.heimdal arc arcd
%endif

###############################################################################
#
# installation
#
###############################################################################

%install

# Build install tree
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT/%{_libexecdir}/arcd
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d

install -m 0555 src/arc $RPM_BUILD_ROOT%{_bindir}
install -m 0555 src/acrontab $RPM_BUILD_ROOT%{_bindir}
install -m 0555 src/cern-config-keytab $RPM_BUILD_ROOT%{_bindir}
ln -f $RPM_BUILD_ROOT%{_bindir}/cern-config-keytab $RPM_BUILD_ROOT%{_bindir}/cern-config-srvtab
install -m 0555 src/arcd $RPM_BUILD_ROOT%{_sbindir}
install -m 0644 src/arcd.xinetd $RPM_BUILD_ROOT/etc/xinetd.d/arcd

install -m 0644 src/*.1 $RPM_BUILD_ROOT/%{_mandir}/man1

install -m 0744 src/arcd.pl $RPM_BUILD_ROOT/%{_libexecdir}/arcd
install -m 0555 src/krb5.conf.cern_mini $RPM_BUILD_ROOT%{_libexecdir}/arcd
install -m 0644 src/logrotate.d_arc $RPM_BUILD_ROOT/etc/logrotate.d/arc
umask 0077
echo "# this file contains Kerberos principals of superusers, one per line" > $RPM_BUILD_ROOT/%{_libexecdir}/arcd/ACL


%clean
echo "Cleaning $RPM_BUILD_ROOT"
[ "$RPM_BUILD_ROOT" != "/" -a "x%{debugspec}" != "x1" ] && \
	rm -fr $RPM_BUILD_ROOT


###############################################################################
###
### scripts
###
###############################################################################

%pre server

%post
grep -q -P '^arc\s*4241/tcp' /etc/services || \
    echo "arc	4241/tcp	# Authenticated Remote Control" >> /etc/services

%post server
if [ -x /usr/bin/chcon ]; then
  # pretend that arcd is something like rshd - i.e. runs from inetd but is unconfined later.
  echo "setting correct SELinux context for arcd"
  /usr/bin/chcon system_u:object_r:rshd_exec_t /usr/sbin/arcd
fi
# semanage is a v5-only thing
if [ -x /usr/sbin/semanage ]; then
    /usr/sbin/semanage fcontext -a -t rshd_exec_t /usr/sbin/arcd || true
fi

if [[ `uname -n` = *cern.ch || "$(cat /etc/resolv.conf)" = *cern.ch* ]]; then
    grep -q CERN.CH /etc/krb5.conf || {
	mv -f /etc/krb5.conf /etc/krb5.conf.rpmorig
	cp -fp %{_libexecdir}/arcd/krb5.conf.cern_mini /etc/krb5.conf
    }
    [ -s /etc/krb.conf ] && {	# validate krb4 only if set up at all
	grep -q CERN.CH /etc/krb.conf || {
	    cp -fp /etc/krb.conf /etc/krb.conf.orig
	    cat > /etc/krb.conf <<EOFkrbAdd
CERN.CH afsdb1.cern.ch
CERN.CH afsdb2.cern.ch
CERN.CH afsdb3.cern.ch
EOFkrbAdd
	    cat /etc/krb.conf.orig >> /etc/krb.conf
	}
    }	
    /sbin/service xinetd status | grep -q running || { /sbin/service xinetd start; }
    cern-config-keytab -f
else
    echo "Make sure a valid \"host/`uname-n`\" entry exists in /etc/krb5.keytab"
fi

chkconfig arcd on

%preun server
[ "$1" = 0 ] && chkconfig arcd off
true

%postun server
#chkconfig --list xinetd 2> /dev/null 1>&2 && {
#    /sbin/service xinetd status | grep -q running || { /sbin/service xinetd reload; }
#}
true

%files
%defattr(0555,root,root)
%{_bindir}/arc
%{_bindir}/acrontab
%{_bindir}/cern-config-keytab
%{_bindir}/cern-config-srvtab
%{_mandir}/man1/arc.1*
%{_mandir}/man1/acrontab.1*

%files server
%defattr(-,root,root)
%attr(0555,root,root) %{_sbindir}/arcd
%attr(0544,root,root) %{_libexecdir}/arcd/arcd.pl
%attr(0544,root,root) %{_libexecdir}/arcd/krb5.conf.cern_mini

%config(noreplace) /etc/xinetd.d/*
%config(noreplace) /etc/logrotate.d/*
%config(noreplace) %{_libexecdir}/arcd/ACL

%changelog
* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 2009.03.02 - 44.20
- avoid chkconfig off when upgrading
* Mon Jan 18 2038 iven <Jan.Iven@cern.ch> 2009.02.09 - 44.20
- SElinux context for arcd, modelled after rshd
* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 2009.01.20 - 44.19
- new cern-config-keytab, some tolerance to krb4-inexistence
* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 2008.10.30 - 44.18
- logrotate (sigh) RHEL4 use size not minsize
* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 2008.10.30 - 44.17
- logrotate arc.log & acron.log
* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 2008.08.26 - 44.16
- spec file mod, 
* Mon Jan 18 2038 rtb <rtb@mail.cern.ch> 2007.07.03 - 44.15
- New cern-config-keytab
